/*      SAMS (Squid Account Management System
 *      Author: Dmitry Chemerik chemerik@mail.ru
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <mysql.h>
#include <math.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <unistd.h>
#include "config.h"
#include "define.h"
#include "tools.h"

struct url_replace {
  char user[25];
  char domain[25];
  char url[50];
  char newurl[50];
};

struct samsusers 
{
  char user[25];
  char domain[25];
  char ip[15];
  char ipmask[15];
  int  enabled;
  int  disabled;
  double size;
  double quote;
  char id[25];
  char date[15];

};
 
struct samsusers *users;
struct url_replace *RUCm;

int IP,NTLM,NCSA,NTLMDOMAIN;
int samsuserscount;
int LCOUNT;

char *local;
int RUC;
int RIPC;
int ucount,rcount;
char path[256];
char rname[150][25];
char rurl[150][25];
char rnew[150][15];
int ucount,rcount;
char *STR[10];
char AUTH[5];
int PRINT,CLEAR,DEBUG,LOADFILE;


char *str2lower(char *string)
{
 //char *original=string;
 while(*string)
     {
        *string=tolower(*string);
        string++;
     }
// return(original);
 return(string);
}

void LoadUsersData(MYSQL *conn)
{
  int i,flag;
  MYSQL_RES *res;
  MYSQL_ROW row;
  char str[BUFFER_SIZE];
      /*    SAMS */
      samsuserscount=0;
      sprintf(&str[0],"SELECT count(nick) FROM squidctrl.squidusers");
      flag=mysql_query(conn,&str[0]);
      res=mysql_store_result(conn);
      row=mysql_fetch_row(res);
      samsuserscount=atoi(row[0]);

      if(DEBUG==1)
        {
           printf("Found %d SAMS users\n",samsuserscount);
        }
      /*     SAMS */
      if((users=(struct samsusers *)malloc(sizeof(struct samsusers)*(samsuserscount+1)))==NULL)
        {
           printf("Not enought memory to allocate buffer\n");
           exit(1);
        }
      /*   SAMS   */
      sprintf(&str[0],"SELECT nick,domain,ip,ipmask,enabled,size,quotes,id FROM squidctrl.squidusers");
      flag=mysql_query(conn,&str[0]);
      res=mysql_store_result(conn);
      for(i=0;i<samsuserscount;i++)
         {
            row=mysql_fetch_row(res);
//            strncpy(users[i].user,str2lower(row[0]),25);
            strncpy(users[i].user,str2lower(row[0]),25);
            strncpy(users[i].domain,str2lower(row[1]),25);
            strncpy(users[i].ip,row[2],15);
            strncpy(users[i].ipmask,str2lower(row[3]),15);
            users[i].enabled=atoi(row[4]);
            users[i].disabled=0;
            users[i].size=atof(row[5]);
            users[i].quote=atof(row[6])*1024*1024;
            strncpy(users[i].id,row[7],25);
            strncpy(users[i].date,"0000-00-00",15);
            if(DEBUG==1)
              {
                 printf("user %2d: %20s %15s %15s %15s %d %10.0f %12.0f %s\n",i,users[i].user,users[i].domain,users[i].ip,users[i].ipmask,users[i].enabled,users[i].size,users[i].quote,users[i].id);
              }
         }
}


void trim(char *string)
{
  char strim[256];
  int i;
  strncpy(&strim[0],"\0",255);
  for(i=0;i<strlen(string);i++)
     {
        if(iscntrl(string[i])==0)
           sprintf(&strim[0],"%s%c",&strim[0],string[i]);
     }
  strncpy(string,&strim[0],255);
}


long GetNewEndValue()
{
  long value;
  FILE *finp;

  trim(&path[0]);
  sprintf(&path[0],"%s/%s",&SQUIDLOGDIR[0],&SQUIDCACHEFILE[0]);
  if((finp=fopen( &path[0], "rb" ))==NULL)
    {
         printf("Don't open file %s/%s\n",&SQUIDLOGDIR[0],&SQUIDCACHEFILE[0]);
         return(0);
    }
  fseek(finp,0,SEEK_END);
  value=ftell(finp);
  fclose(finp);
  return(value);
}

long txt2digit(char *str)
{
  int len,i,base=0;
  double value;
  value=0;
  len=strlen(str);
  for(i=0;i<len;i++)
     {
        if(isdigit(str[i])!=0)
          {
            switch(str[i])
              {
                case '1':               base=1; break;
                case '2':               base=2; break;
                case '3':               base=3; break;
                case '4':               base=4; break;
                case '5':               base=5; break;
                case '6':               base=6; break;
                case '7':               base=7; break;
                case '8':               base=8; break;
                case '9':               base=9; break;
                case '0':               base=0; break;
              }
            value+=base*pow(10,len-i-1);
         }
     }
  return(value);
}


void SaveNewEndFileValue(MYSQL *conn,long count)
{
  char str[BUFFER_SIZE];
  int flag;
  sprintf(&str[0],"UPDATE squidctrl.sams SET endvalue=\'%ld\'",count);
  flag=mysql_query(conn,&str[0]);
  if(flag!=0)
    {
       printf("error: can't update end file counter\n");
       exit(1);
    }
  if(DEBUG!=0)
    printf("Save new access.log file size\n");
}


int LocalURL(char *url)
{
  int i;
  if(DEBUG>0)
       printf("test url %s ... ",url);
  for(i=0;i<LCOUNT;i++)
     {
        if(strstr(url,local+i*50)!=0)
          {
             if(DEBUG>0)
                  printf("LOCALHOST!!!\n");
	    return(1);
          }
     }
  if(DEBUG>0)
       printf(" not localhost\n");
  return(0);
}


int ReplaceCHR(char *str)
{
  char *pos;
  if(str[0]=='\0')
     return(1);
  pos=strstr(str,"'");
  while(pos>0)
    {
        strcpy(pos,pos+1);
        pos=strstr(str,"'");
    }
 return(0);
}


int ControlUserName(char *user,char *domain)
{
 return(0);
}

int DisableUser(char *string)
{
  FILE *fout;
  fout=fopen("/tmp/sams/disable.sams","w");
  fwrite(string,strlen(string),1,fout);
  fclose(fout);
  return(0);
}


int ReturnSAMSUser(char *username, char *domain)
{
  int i;
  char ip[15];
  int ip1[4];
  int ip2[4];

  if(IP!=0)
    {
      strncpy(&ip[0],username,15);
      ip1[0]=atoi(strtok(ip,"."));
      ip1[1]=atoi(strtok(NULL,"."));
      ip1[2]=atoi(strtok(NULL,"."));
      ip1[3]=atoi(strtok(NULL,"."));
      for(i=0;i<samsuserscount;i++)
         {
            if(strlen(users[i].ip)>4)
              {
                strncpy(&ip[0],users[i].ip,15);
                ip2[0]=atoi(strtok(ip,"."));
                ip2[1]=atoi(strtok(NULL,"."));
                ip2[2]=atoi(strtok(NULL,"."));
                ip2[3]=atoi(strtok(NULL,"."));
                if(ip1[0]==ip2[0]&&ip1[1]==ip2[1]&&ip1[2]==ip2[2]&&ip1[3]==ip2[3])
                  {
                    return(i+1);
                  }
              }
	 }    
     }
  if(NTLM!=0)
    {
      for(i=0;i<samsuserscount;i++)
         {
           if(strcmp(username,users[i].user)==0&&strcmp(domain,users[i].domain)==0)
             {
               return(i+1);
             }
	 }    
     }
  if(NCSA!=0)
    {
      for(i=0;i<samsuserscount;i++)
         {
           if(strcmp(username,users[i].user)==0)
             {
               return(i+1);
             }
	 }    
     }
 return(0);
}

void ReplaceURL(char *url, char *user, char *domain)
{
  char *p;
  int i;
  strncpy(&path[0],url,255);
  for(i=0;i<RUC;i++)
     {
        if(strstr(url,RUCm[i].url)!=0&&strstr(user,RUCm[i].user)!=0&&strstr(domain,RUCm[i].domain)!=0)
          {
            p=strtok(&path[0],"/");
            p=strtok(NULL,"/");
            p=strtok(NULL,"/");
            sprintf(&path[0],"%s/%s",RUCm[i].newurl,p);
          }
     }
}



void ReadNewData(MYSQL *conn,MYSQL *conn2)
{
  char buf[BUFFER_SIZE];
  char str[BUFFER_SIZE];
  char rf[10];
//  FILE *finp;
  int finp;
  char *user=NULL,*domain=NULL,*status=NULL;
  int i,flag,flag0;
  int str7len=0;
  time_t tt,tt2;
  struct tm *t,*t2;
  long hitsize;
  double size;
  int samsuser;
  MYSQL_RES *res;
  MYSQL_ROW row;
  struct stat st;
  int userflag=0;

  sprintf(&path[0],"%s/%s",&SQUIDLOGDIR[0],&SQUIDCACHEFILE[0]);
  trim(&path[0]);
  
  tt2=time(NULL);
  
  
  stat( &path[0], &st );
  switch(st.st_mode & S_IFMT)
    {
      case S_IFSOCK:
      case S_IFLNK:
      case S_IFCHR:
      case S_IFBLK:
      case S_IFDIR:
      case S_IFREG:    
           tt=time(NULL);
           t=localtime(&tt);
           sprintf(&str[0],"%s/%s.%d%d%d",&SQUIDLOGDIR[0],&SQUIDCACHEFILE[0],t->tm_year+1900,t->tm_mon+1,t->tm_mday);
	   rename(&path[0],&str[0]);
           break;
    }       

  if(access(&path[0],F_OK)!=0)
    {
      if(mknod(&path[0],S_IFIFO|0666,0)<0)
        {
           printf("make FIFO error\n");
           exit(1);
        }  
      chmod(&path[0],0666); 	
    }
  if((finp=open(&path[0],O_RDONLY))<0)
    {
      printf("i can't open FIFO for reading\n");
      exit(1);
    }
  printf("open fifo BUFFER_SIZE=%d\n",BUFFER_SIZE);

  while(read(finp,&rf[0],1)>0)
    {
      if(rf[0]!='\n')
        {
          strncat(&buf[0],&rf[0],1);
	}
      else
        {
           tt=time(NULL);
	   if(tt>(tt2+2000))
	     {
               if(DEBUG==1) 
	         { 
                    t=localtime(&tt);
                    t2=localtime(&tt2);
                    printf("time=%d:%d:%d > %d:%d:%d (%d>%d)  test reconfig flag\n",t->tm_hour,t->tm_min,t->tm_sec,t2->tm_hour,t2->tm_min,t2->tm_sec,(int)tt,(int)tt2);
		 }  
	       tt2=tt;
 
               sprintf(&str[0],"SELECT action,service FROM squidctrl.reconfig WHERE service='samsf'&&action='reconfig'");
               flag=mysql_query(conn2,&str[0]);
               res=mysql_store_result(conn2);
               //    SAMSF
               if(mysql_num_rows(res)>0)  
                 {
                   sprintf(&str[0],"DELETE FROM squidctrl.reconfig WHERE service='samsf'&&action='reconfig'");
                   flag=mysql_query(conn2,&str[0]);
                   if(flag!=0)
                     {
                       //printf("error: can't update end file counter\n");
                       exit(1);
                     }
                   free(users);
                   LoadUsersData(conn2);
	         }
	     }
           if(DEBUG>0||PRINT>0)
             {
               printf("string: %s\n",&buf[0]);
             }
/*  */
           flag0=ReplaceCHR(&buf[0]);
           if(strstr( &buf[0], "TCP_DENIED" )==0&&strstr( &buf[0], "UDP_DENIED" )==0&&flag0==0)
             {
                STR[0]=strtok(&buf[0]," ");
                for(i=1;i<9;i++)
                  {
                     STR[i]=strtok(NULL," ");
                  }
                flag=0;
                str7len=0;
                userflag=0;
                hitsize=0;
                samsuser=0;

                str2lower(STR[7]);

                //  NTLM domain+user?
                if(NTLM>0&&NTLMDOMAIN>0)
                  {
                    if(strstr(STR[7],"+")!=0)
                      {
                        domain=strtok(STR[7],"+");
                        user=strtok(NULL,"+");
                        samsuser=ReturnSAMSUser(user,domain);
                        userflag=1;
                      }
                    if(strstr(STR[7],"\\")!=0)
                      {
                        domain=strtok(STR[7],"\\");
                        user=strtok(NULL,"\\");
                        samsuser=ReturnSAMSUser(user,domain);
                        userflag=1;
                      }
                  }

                if(NCSA!=0||(NTLM>0&&NTLMDOMAIN==0))
                  {
                     strcpy(str,STR[7]);
                     if((samsuser=ReturnSAMSUser(str,""))>0)
                       {
                          domain=users[samsuser-1].domain;
                          user=users[samsuser-1].user;
                          if(DEBUG!=0)
                            printf("found user: %s/%s \n",domain,user);
                          userflag=1;
		       }	  
                  }
                if(IP!=0)
                  {
                     strcpy(str,STR[2]);
                     if((samsuser=ReturnSAMSUser(str,""))>0)
                       {
                         domain=users[samsuser-1].domain;
                         user=users[samsuser-1].user;
                         if(DEBUG!=0)
                            printf("found user: %s/%s, ip=%s\n",domain,user,users[samsuser-1].ip);
                         userflag=1;
                       }

		  }

                tt=atol(STR[0]);
                t=localtime(&tt);
/**********/
                status=strtok(STR[3],"/");
                if(strstr( status, "_HIT" )!=0&&strstr( status, "_NEGATIVE_" )==0)
                  {
                    hitsize=atof(STR[4]);
                  }
                if(strcmp( status, "TCP_DENIED" )!=0&&strcmp( status, "UDP_DENIED" )!=0&&userflag!=0&&LocalURL(STR[6])==0)
                  {
                    size=atof(STR[4]);
		    users[samsuser-1].size+=size;

 		    sprintf(&str[0],"UPDATE squidctrl.squidusers SET size='%12.0f' WHERE id='%s'",users[samsuser-1].size,users[samsuser-1].id);
                    flag=mysql_query(conn2,&str[0]);

                    if(users[samsuser-1].quote>0)
		      {
                        if(users[samsuser-1].size>=users[samsuser-1].quote)
		          {
                            if(users[samsuser-1].disabled==0)
			      {
			        users[samsuser-1].disabled=1;
			        users[samsuser-1].enabled=0;
                                if(DEBUG!=0||PRINT!=0)
                                  printf("User %s/%s disabled.  traffic size = %12.0f quote = %12.0f\n",users[samsuser-1].domain,users[samsuser-1].user,users[samsuser-1].size,users[samsuser-1].quote);
			        sprintf(&str[0],"UPDATE squidctrl.squidusers SET enabled='0' WHERE id='%s'",users[samsuser-1].id);
                                flag=mysql_query(conn2,&str[0]);
			        sprintf(&str[0],"UPDATE squidctrl.reconfig SET action='reconfig',service='squid'");
                                flag=mysql_query(conn2,&str[0]);
			      }  
		          }
		      }	  
                    if(DEBUG!=0)
                      printf(" %s/%s, ip=%s traffic size=%10f traffic=%10.0f quote=%12.0f\n",users[samsuser-1].domain,users[samsuser-1].user,users[samsuser-1].ip,size,users[samsuser-1].size,users[samsuser-1].quote);

                    ReplaceURL(STR[6],user,domain);
                    sprintf(&str[0],"INSERT INTO squidlog.cache SET date='%d-%d-%d',time='%d:%d:%d',size='%s',ipaddr='%s',url='%s',user='%s',domain='%s',hit='%lu'",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec,STR[4],STR[2],&path[0],user,domain,hitsize);

                    flag=mysql_query(conn,&str[0]);
                    if(PRINT!=0||DEBUG!=0)
                       printf("set: %d-%d-%d %d:%d:%d %s/%s %s %s\n",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec,user,domain,STR[4],&path[0]);
                    if(flag!=0)
                      {
                         printf("error: %s\n",&str[0]);
                         printf("Error %u (%s)\n",mysql_errno(conn),mysql_error(conn));
                         for(i=0;i<samsuserscount;i++)
                            {
  	                      sprintf(&str[0],"UPDATE squidctrl.squidusers SET size='%20.0f' WHERE id='%s'",users[i].size,users[i].id);
                              flag=mysql_query(conn2,&str[0]);
                              if(DEBUG!=0)
                                printf("update user size: %s/%s %20.0f\n",users[i].domain,users[i].user,users[i].size);
	                    }    
                         exit(1);
                      }

                    sprintf(&str[0],"%d-%d-%d",t->tm_year+1900,t->tm_mon+1,t->tm_mday);

		    if(strcmp(&str[0],users[samsuser-1].date)!=0)
		      {
                         sprintf(&str[0],"SELECT count(*) FROM squidlog.cachesum WHERE date='%d-%d-%d'&&user='%s'&&domain='%s'",t->tm_year+1900,t->tm_mon+1,t->tm_mday,user,domain);
                         flag=mysql_query(conn,&str[0]);
                         res=mysql_store_result(conn);
                         row=mysql_fetch_row(res);
			 
                         if(atoi(row[0])==0)
                           {
			     strncpy(users[samsuser-1].date,&str[0],10);
                             sprintf(&str[0],"INSERT squidlog.cachesum SET size='%s',hit='%lu',date='%d-%d-%d',user='%s',domain='%s'",STR[4],hitsize,t->tm_year+1900,t->tm_mon+1,t->tm_mday,user,domain);
                             flag=mysql_query(conn,&str[0]);
			   }  
			 else
			   {
                             sprintf(&str[0],"UPDATE squidlog.cachesum SET size=size+'%s',hit=hit+'%lu' where date='%d-%d-%d'&&user='%s' && domain='%s'",STR[4],hitsize,t->tm_year+1900,t->tm_mon+1,t->tm_mday,user,domain);
                             flag=mysql_query(conn,&str[0]);
			   }  
                         mysql_free_result(res);
		      
		      }
                    else
		      {
                         sprintf(&str[0],"UPDATE squidlog.cachesum SET size=size+'%s',hit=hit+'%lu' where date='%d-%d-%d'&&user='%s' && domain='%s'",STR[4],hitsize,t->tm_year+1900,t->tm_mon+1,t->tm_mday,user,domain);
                         flag=mysql_query(conn,&str[0]);
		      
		      } 


                    if(DEBUG>0)
                      {
                          printf("database appended\n");
                      }
		                  
                  }
             }

/*   */
	  strcpy(&buf[0],"\0");
	}	  
    }     
  close(finp);
}



int main (int argc, char *argv[])
{
  int i;
  MYSQL *conn,*conn2;
  MYSQL_RES *res;
  MYSQL_ROW row;
  static char str[BUFFER_SIZE];
  int flag;
//  int pid ;
  pid_t pid,parentpid,childpid;
  
  printf("\n");

  for(i=0;i<argc;i++)
     {
       if(strstr(argv[i],"--help")!=0||strstr(argv[i],"-h")!=0)
          {
            printf("Usage: samsf [options]\n");
            printf(" -h, --help       show this message.\n");
            printf(" -p, --print      print additional information.\n");
            printf(" -d, --debug      print debug message.\n");
            exit(0);
          }
       if(strstr(argv[i],"--print")!=0||strstr(argv[i],"-p")!=0)
          {
            PRINT=1;
          }
       if(strstr(argv[i],"--debug")!=0||strstr(argv[i],"-d")!=0)
          {
            DEBUG=1;
          }
     }



  pid = getpid();
  if(DEBUG==1)
    {
      printf("Starting process: pid = %d\n",pid);
    }  
  if(access("/var/run/samsf.pid",F_OK)==0)
    {
      if(TestPID("/var/run/samsf.pid")!=0)
         exit(0);
    }
  readconf();

  conn = do_connect(&MYSQLHOSTNAME[0],&MYSQLUSER[0], &MYSQLPASSWORD[0],
                   &MYSQLDATABASE[0], def_port_num, def_socket_name, 0);
  if (conn == NULL)
                    exit(1);
  conn2 = do_connect(&MYSQLHOSTNAME[0],&MYSQLUSER[0], &MYSQLPASSWORD[0],
                   &SQUIDCTRLDATABASE[0], def_port_num, def_socket_name, 0);
  if (conn2 == NULL)
                    exit(1);

  sprintf(&str[0],"SELECT endvalue,auth,ntlmdomain FROM squidctrl.sams");
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  row=mysql_fetch_row(res);
  IP=0;
  NCSA=0;
  NTLM=0; 
  if(strcmp(row[1],"ncsa")==0)
    {
      NCSA=1;
    }
  if(strcmp(row[1],"ntlm")==0)
    {
      NTLM=1;
    }
  if(strcmp(row[1],"ip")==0)
    {
      IP=1;
    }
  if(strcmp(row[2],"Y")==0)
    {
      NTLMDOMAIN=1;
    }
  mysql_free_result(res);

  LoadUsersData(conn);

/*  */
  sprintf(&str[0],"SELECT count(*) FROM squidctrl.urls WHERE type='local'");
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  row=mysql_fetch_row(res);
  LCOUNT=txt2digit(row[0]);
  mysql_free_result(res);
  if(DEBUG>0)
    printf("Found %d localhosts \n",LCOUNT);

  if((local=(char *)malloc(LCOUNT*50))==NULL)
     {
       printf("Not enought memory to allocate buffer\n");
       exit(1);
     }
  sprintf(&str[0],"SELECT * FROM squidctrl.urls WHERE type='local'");
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  for(i=0;i<LCOUNT;i++)
     {
         row=mysql_fetch_row(res);
         strncpy(local+i*50,row[0],50);
         if(DEBUG>0)
            printf(" %s\n",local+i*50);
     }
  mysql_free_result(res);
/*  */

  sprintf(&str[0],"SELECT count(*) FROM squidctrl.urlreplace");
  if(PRINT>0||DEBUG>0)
    printf("2. %s \n",&str[0]);
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  row=mysql_fetch_row(res);
  RUC=txt2digit(row[0]);
  mysql_free_result(res);

  if((RUCm=(struct url_replace *)malloc(sizeof(struct url_replace)*(RUC+1)))==NULL)
     {
       printf("Not enought memory to allocate buffer\n");
       exit(1);
     }
  sprintf(&str[0],"SELECT * FROM squidctrl.urlreplace");
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  for(i=0;i<RUC;i++)
     {
         row=mysql_fetch_row(res);
         strncpy(RUCm[i].user,row[0],25);
         strncpy(RUCm[i].domain,row[1],25);
         strncpy(RUCm[i].url,row[2],50);
         strncpy(RUCm[i].newurl,row[3],50);
         if(DEBUG!=0)
            printf(" %s %s %s %s\n",RUCm[i].user,RUCm[i].domain,RUCm[i].url,RUCm[i].newurl);
     }
  mysql_free_result(res);

  parentpid=getppid();

  if(DEBUG==0)
    childpid=fork();

//  printf("childpid=%d DEBUG==%d\n",childpid,DEBUG);    
  if(childpid==0||(childpid!=0&&DEBUG==1))
    {
      pid = getpid();
      if(SavePID(pid,"/var/run/samsf.pid")!=0)
          exit(0);
      printf("Starting child process\n");
      ReadNewData(conn,conn2);
      RmPID("/var/run/samsf.pid");
    }
  free(users);
  free(local);
  free(RUCm);

  return(0);
}
