/*      SAMS (Squid Account Management System
 *      Author: Dmitry Chemerik chemerik@mail.ru
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <mysql.h>
#include <math.h>
#include <ctype.h>

#include "config.h"
#include "define.h"
#include "tools.h"


struct samsusers 
{
  char user[25];
  char domain[25];
  char ip[15];
  char ipmask[15];
  char shablon[25];
  int enabled;
};

struct samsshablons 
{
  char name[25];
  char list[25];
  long sm;
  long len;
};

struct samsurls 
{
  char url[90];
  char list[25];
  char type[25];
};


struct samsusers *users;
struct samsurls *urls;
struct samsshablons *shablons;
int samsshablonscount,samsurlscount,samslistcount, samsuserscount,smcount;
char samsuser[256];
char samsdomain[256];
int DEBUG,NCSA,IP,NTLM,NCSA,NTLMDOMAIN,USERNUMBER;
int REDIRECT,DENIED,USERDENIED,ALLOW,URLALLOW;


void ReturnFullDomainName(char *domainname,char *url)
{
  int i=0,count=0,slashe=0,t1=0,t2=0,j=0;
  for(i=0,count=0,t2=0;i<strlen(url);i++)
     {
        if(url[i]=='.')
           { 
              t1=t2;  t2=i;
           }

        if(url[i]=='/')
           { 
             count++;
             if(count>=3)
                {
                   count=i-1;
                   break;
                }
             slashe=i;
           }
     }
  if(t1<slashe)
     t1=slashe;
  count=i;
  for(i=slashe+1,j=0;i<count;i++,j++)
     {
        if(url[i]=='-')
           domainname[j]='%';
        else
           domainname[j]=url[i];
     }
  domainname[j]='\0';
}



void ReturnDomainName(char *domainname,char *url)
{
  int i=0,count=0,slashe=0,t1=0,t2=0,j=0;
  for(i=0,count=0,t2=0;i<strlen(url);i++)
     {
        if(url[i]=='.')
           { 
              t1=t2;  t2=i;
           }

        if(url[i]=='/')
           { 
             count++;
             if(count>=3)
                {
                   count=i-1;
                   break;
                }
             slashe=i;
           }
     }
  if(t1<slashe)
     t1=slashe;
  domainname[0]='%';
  count=i;
  for(i=t1+1,j=1;i<count;i++,j++)
     {
        if(url[i]=='-')
           domainname[j]='%';
        else
           domainname[j]=url[i];
     }

  domainname[j]='%';
  domainname[j+1]='\0';
}

void trim(char *string)
{
  char strim[BUFFER_SIZE];
  int i;
  strncpy(&strim[0],"\0",BUFFER_SIZE-1);
  for(i=0;i<strlen(string);i++)
     {
        if(iscntrl(string[i])==0)
           sprintf(&strim[0],"%s%c",&strim[0],string[i]);
     }
  strncpy(string,&strim[0],254);
} 


char *str2lower(char *string)
{
 char *original=string;
 while(*string)
     {
        *string=tolower(*string);
        string++;
     }
 return(original);
}


int UserAccess(char *str1,char *str2)
{ 
  int i;
  char str3[100];

  if (IP!=0)
    { 
       for(i=0;i<samsuserscount;i++)
          {
	    if(strcmp(str1,users[i].ip)==0&&users[i].enabled>0)
              { 
		return(i+1);
              }
	  }
    }
  if(NTLM!=0&&NTLMDOMAIN!=0)  
    { 
       for(i=0;i<samsuserscount;i++)
          {
             strncpy(&samsuser[0],users[i].user,255);
             strncpy(&samsdomain[0],users[i].domain,255);
             strcat(&samsuser[0],"\0");
	     strcat(&samsdomain[0],"\0");
             if(strstr(str1,"+")!=0)
               {
                 sprintf(&str3[0],"%s+%s",users[i].domain,users[i].user);
               }
             else if(strstr(str1,"\\")!=0)
               {
                 sprintf(&str3[0],"%s\\%s",users[i].domain,users[i].user);
	       } 
             else
	       {
                 sprintf(&str3[0],"%s%s",users[i].domain,users[i].user);
	       }
	     if(strcmp(str1,&str3[0])==0&&users[i].enabled>0)
               {
                 return(i+1);
	       }
             strcpy(&samsuser[0],"\0");
	     strcpy(&samsdomain[0],"\0");
	  }
    }
	  
  if(NCSA!=0||(NTLM!=0&&NTLMDOMAIN==0))  
    {
       for(i=0;i<samsuserscount;i++)
          {
            if(strcmp(str1,users[i].user)==0)
              {
                return(i+1);
	      }
	  }    
    }
	      				 
  return(0);
}








int main (int argc, char *argv[])
{
  int i=0,j=0,k=0,flag=0,ipaddrflag=0;
  MYSQL *conn;
  MYSQL_RES *res, *res2;
  MYSQL_ROW row, row2;
  static char domainname[BUFFER_SIZE];
  static char str[BUFFER_SIZE];
  static char str1[BUFFER_SIZE];
  static char str2[BUFFER_SIZE];
  static char str2_[BUFFER_SIZE];
  static char str3[BUFFER_SIZE];
  static char str4[BUFFER_SIZE];
  static char redir_to[120];
  static char denied_to[120];
  char *user=NULL,*domain=NULL;
  char separator;

  NCSA=0;
  for(i=0;i<argc;i++)
     {
       if(strstr(argv[i],"--help")!=0||strstr(argv[i],"-h")!=0)
          {
            printf("Usage: sams [options]\n");
            printf(" -h, --help       show this message.\n");
            printf(" -d, --debug      print debug message.\n");
            exit(0);
          }
       if(strstr(argv[i],"--debug")!=0||strstr(argv[i],"-d")!=0)
          {
            DEBUG=1;
          }
     }

  readconf();
  conn = do_connect(&MYSQLHOSTNAME[0],&MYSQLUSER[0], &MYSQLPASSWORD[0],
                   &MYSQLDATABASE[0], def_port_num, def_socket_name, 0);
  if (conn == NULL)
                    exit(1);

//  fflush(stdout);
  sprintf(&str[0],"SELECT squidctrl.sams.redirect_to,squidctrl.sams.denied_to,squidctrl.sams.auth,squidctrl.sams.ntlmdomain FROM squidctrl.sams");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);

  strncpy(&redir_to[0],row[0],119);
  strncpy(&denied_to[0],row[1],119);
  if(strcmp(row[2],"ip")==0)
    {
       IP=1;
       ipaddrflag=1;
       if(DEBUG==1)
         {
            printf("authentification: IP addr\n");
         }
    }
  if(strcmp(row[2],"ntlm")==0)
    {
       NTLM=1;
       if(DEBUG==1)
         {
            printf("authentification: NTLM\n");
         }
    }
  if(strcmp(row[2],"ncsa")==0)
    {
	  NCSA=1;
          if(DEBUG==1)
            printf("authentification: NCSA\n");
    }
  if(strcmp(row[3],"Y")==0)
    {
      NTLMDOMAIN=1;
    }

  mysql_free_result(res);

  /*    SAMS */
  samsuserscount=0;
  sprintf(&str[0],"SELECT count(nick) FROM squidctrl.squidusers");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  samsuserscount=atoi(row[0]);

  if(DEBUG==1)
    {
       printf("Found %d SAMS users\n",samsuserscount);
    }
  /*     SAMS */
  if((users=(struct samsusers *)malloc(sizeof(struct samsusers)*samsuserscount))==NULL)
     {
       printf("Not enought memory to allocate buffer\n");
       exit(1);
     }

  /*   SAMS   */
  sprintf(&str[0],"SELECT nick,domain,ip,ipmask,enabled,shablon FROM squidctrl.squidusers");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<samsuserscount;i++)
     {
        row=mysql_fetch_row(res);
//        strncpy(users[i].user,str2lower(row[0]),25);
        strncpy(users[i].user,row[0],25);
//        strncpy(users[i].domain,str2lower(row[1]),25);
        strncpy(users[i].domain,row[1],25);
        strncpy(users[i].ip,row[2],15);
        strncpy(users[i].ipmask,row[3],15);
        users[i].enabled=atoi(row[4]);
        strncpy(users[i].shablon,row[5],15);
        if(DEBUG==1)
          {
             printf("user %2d: %20s %15s %16s %16s %d %s\n",i,users[i].user,users[i].domain,users[i].ip,users[i].ipmask,users[i].enabled,users[i].shablon);
          }
     }



  /*     */
  samsshablonscount=0;
  sprintf(&str[0],"SELECT count(sname) FROM squidctrl.sconfig");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  samsshablonscount=atoi(row[0]);
  if(DEBUG==1)
    {
       printf("Found %d    \n",samsshablonscount);
    }
  /*      */
  if((shablons=(struct samsshablons *)malloc(sizeof(struct samsshablons)*samsshablonscount))==NULL)
     {
       printf("Not enought memory to allocate buffer\n");
       exit(1);
     }
  /*       */
  sprintf(&str[0],"SELECT * FROM squidctrl.sconfig");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<samsshablonscount;i++)
     {
        row=mysql_fetch_row(res);
        strncpy(shablons[i].name,row[0],25);
        strncpy(shablons[i].list,row[1],25);
        shablons[i].sm=0;
        shablons[i].len=0;
        if(DEBUG==1)
          {
             printf("list %d: %25s %25s  %ld\n",i,shablons[i].name,shablons[i].list,shablons[i].sm);
          }
     }


  /*   URL  */
  samslistcount=0;
  sprintf(&str[0],"SELECT count(filename) FROM squidctrl.redirect");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  samslistcount=atoi(row[0]);
  if(DEBUG==1)
    {
       printf("Found %d  \n",samslistcount);
    }
  sprintf(&str[0],"SELECT filename,type FROM squidctrl.redirect ");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  smcount=1;
  for(i=0;i<samslistcount;i++)
     {
       row=mysql_fetch_row(res);
       sprintf(&str[0],"SELECT count(url) FROM squidctrl.urls WHERE type='%s'",row[0]);
       //printf("%s\n",&str[0]); 
       flag=mysql_query(conn,&str[0]);
       res2=mysql_store_result(conn);
       row2=mysql_fetch_row(res2);
       for(j=0;j<samsshablonscount;j++)
          {
	    if(strcmp(shablons[j].list,row[0])==0)
	      {
                 shablons[j].sm=smcount-1;
                 shablons[j].len=atoi(row2[0]);
                 if(DEBUG==1)
                    printf("        %25s %25s  %ld len=%ld \n",shablons[j].name,shablons[j].list,shablons[j].sm,shablons[j].len);
	      }
	  }
       smcount+=atoi(row2[0]);
     }

  samsurlscount=smcount;
  if(DEBUG==1)
    {
       printf("Found %d URL\n",samsurlscount);
    }
  /*    URL */
  if((urls=(struct samsurls *)malloc(sizeof(struct samsurls)*(samsurlscount+10)))==NULL)
     {
       printf("Not enought memory to allocate buffer\n");
       exit(1);
     }

  k=1;
  sprintf(&str[0],"SELECT filename,type FROM squidctrl.redirect ");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<samslistcount;i++)
     {
       row=mysql_fetch_row(res);

       if(strcmp("localhosts",row[0])!=0)
         {
            sprintf(&str[0],"SELECT urls.url,urls.type FROM squidctrl.urls WHERE type='%s'",row[0]);
            flag=mysql_query(conn,&str[0]);
            res2=mysql_store_result(conn);
            while((row2=mysql_fetch_row(res2))!=NULL)
              {
                 strncpy(urls[k].url,row2[0],90);
                 strncpy(urls[k].list,row2[1],25);
                 strncpy(urls[k].type,row[1],25);
                 //printf("      load url %d %3d: %45s %10s %s \n",i,k,urls[k].url,urls[k].type,urls[k].list);
                 k++;
              }
         }
     }

 do_disconnect(conn);


//exit(0);




  while(fgets(&str[0], BUFFER_SIZE, stdin)!=NULL)
      {
        if(DEBUG==1)
           printf("read stdin:  %s",&str[0]);

        USERNUMBER=0;
        REDIRECT=0;
	DENIED=0;
	USERDENIED=0;
        URLALLOW=0;
        ALLOW=0;
        trim(&str[0]);

        if(strlen(&str[0])>0)
           {
             strncpy(&str1[0],strtok(&str[0]," "),BUFFER_SIZE-1);
             strncpy(&str2_[0],strtok(NULL," "),254);
             strncpy(&str3[0],strtok(NULL," "),254);
             strncpy(&str4[0],strtok(NULL," "),254);
             strncpy(&str2[0],strtok(&str2_[0],"/"),254);
             ReturnFullDomainName(&str[0],&str1[0]);
             if(DEBUG==1)
                   printf("   decode data: URI=%s IP=%s USER=%s TYPE=%s\n",&str1[0],&str2[0],&str3[0],&str4[0]);
             if(NTLM!=0||NCSA!=0)
               { 

                 if(DEBUG==1&&NCSA!=0)  printf("   authentication: ncsa \n");
                 if(DEBUG==1&&NTLM!=0&&NTLMDOMAIN!=0)  printf("   authentication: ntlm (domain+username) \n");
                 if(DEBUG==1&&NTLM!=0&&NTLMDOMAIN==0)  printf("   authentication: ntlm (username) \n");

                 USERNUMBER=UserAccess(&str3[0],&str4[0]);
                 if(USERNUMBER==0)
		   {
                      USERDENIED=1;
                   }  
                 else
		   {
                      if(DEBUG==1)
                        printf("   found user: %s+%s %s\n",users[USERNUMBER-1].domain,users[USERNUMBER-1].user,users[USERNUMBER-1].shablon);

                          strcpy(&domainname[0],"\0"); 
                          ReturnDomainName(&domainname[0],&str1[0]);

                          if(NTLM!=0)
                            {
                              if(strcmp(&str3[0],"-")==0)
                                {
                                   strncpy(&str3[0],"\0",254);
                                   domain=&str3[0];
	                           user=&str3[0];
                                   separator='-';
                                }   
                              else
                                {
                                  domain=&samsdomain[0];
                                  user=&samsuser[0];
                                  if(strstr(&str3[0],"+")!=0)
                                                                separator='+';
                                  else if(strstr(&str3[0],"\\")!=0)
                                                                strncpy(&separator,"\\",1);
				  else
                                                                strncpy(&separator,"\0",1);
                                }
			    }
                          if(NCSA!=0)
			    {
	                        user=&str3[0];
				domain="";
			    } 

                          for(i=0;i<samsshablonscount;i++)
			    {
			        if(strcmp(users[USERNUMBER-1].shablon,shablons[i].name)==0)
                                  {
                                     if(DEBUG==1)
				        printf("   %s+%s %s %s %s %ld %ld\n",users[USERNUMBER-1].user,users[USERNUMBER-1].domain,users[USERNUMBER-1].shablon,shablons[i].name,shablons[i].list,shablons[i].sm,shablons[i].len);
				     for(j=0;j<shablons[i].len;j++)
				        {
					  k=shablons[i].sm+j;
                                          if(strcmp(urls[k].type,"allow")==0)
					    {
						   URLALLOW=1;
					    }
					  if(strstr(&str1[0],urls[k].url)!=0)
					    {
                                              if(strcmp(urls[k].type,"allow")==0)
					        {
                                                   ALLOW=1;
						   if(DEBUG==1)
				                      printf("step 3.        URL ALLOW!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"denied")==0)
					        {
                                                   DENIED=1;
						   if(DEBUG==1)
				                      printf("        DENIED!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"redir")==0)
					        {
                                                   REDIRECT=1;
						   if(DEBUG==1)
				                      printf("        REDIR!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"regex")==0)
					        {
                                                   DENIED=1;
						   if(DEBUG==1)
				                      printf("        REGEX!!! %s %s\n",urls[k].url,&str1[0]);
						}
					      
					    }
					}
				  }
			    }
                   }

                 if(URLALLOW!=0&&ALLOW==0)
                    {
                      sprintf(&str1[0],"%s/urldenied.html",&denied_to[0]);
		    }  
                 if(USERDENIED!=0)
                    {
                      sprintf(&str1[0],"%s/denied.html",&denied_to[0]);
		    }  
                 if(DENIED!=0)
                    {
                      sprintf(&str1[0],"%s/urldenied.html",&denied_to[0]);
		    }  
                 if(REDIRECT!=0)
                    {
                      strncpy(&str1[0],&redir_to[0],254);
		    }  
                 sprintf(&str[0],"%s %s/- %s %s",&str1[0],&str2[0],&str3[0],&str4[0]);
                 fprintf(stdout,"%s\n",&str[0]);
                     
               }

/*          IP      */
             if(IP!=0)
               { 
                 if(DEBUG==1)  printf("     authentication: ip \n");

                 USERNUMBER=UserAccess(&str2[0],&str4[0]);
                 if(USERNUMBER==0)
		   {
                      USERDENIED=1;
                   }  
                 else
		   {
                      if(DEBUG==1)
                        printf("   found user: %s, %s %s\n",users[USERNUMBER-1].ip,users[USERNUMBER-1].user,users[USERNUMBER-1].shablon);

                          strcpy(&domainname[0],"\0"); 
                          ReturnDomainName(&domainname[0],&str1[0]);

                          for(i=0;i<samsshablonscount;i++)
			    {
			        if(strcmp(users[USERNUMBER-1].shablon,shablons[i].name)==0)
                                  {
                                     if(DEBUG==1)
				        printf("   %s, %s %s %s %s %ld %ld\n",users[USERNUMBER-1].ip,users[USERNUMBER-1].user,users[USERNUMBER-1].shablon,shablons[i].name,shablons[i].list,shablons[i].sm,shablons[i].len);
				     for(j=0;j<shablons[i].len;j++)
				        {
					  k=shablons[i].sm+j;
					  if(DEBUG==1)
				            printf("       testing URL: %s URL list %s i=%d j=%d sm=%ld\n",urls[k].url,shablons[i].list,i,j,shablons[i].sm+j);
                                          if(strcmp(urls[k].type,"allow")==0)
					    {
						   URLALLOW=1;
						   //if(DEBUG==1)
				                   //   printf("        URLALLOW =  %d  !!!\n",URLALLOW);
					    }
					  if(strstr(&str1[0],urls[k].url)!=0)
					    {
                                              if(strcmp(urls[k].type,"allow")==0)
					        {
                                                   ALLOW=1;
						   if(DEBUG==1)
				                      printf("        URL ALLOW!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"denied")==0)
					        {
                                                   DENIED=1;
						   if(DEBUG==1)
				                      printf("        DENIED!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"redir")==0)
					        {
                                                   REDIRECT=1;
						   if(DEBUG==1)
				                      printf("        REDIR!!! %s %s\n",urls[k].url,&str1[0]);
						}
                                              if(strcmp(urls[k].type,"regex")==0)
					        {
                                                   DENIED=1;
						   if(DEBUG==1)
				                      printf("        REGEX!!! %s %s\n",urls[k].url,&str1[0]);
						}
					    }
					}
				  }
			    }
                   }

   	        // if(DEBUG==1)
                //      printf("        URLALLOW = %d  ALLOW = %d\n",URLALLOW,ALLOW);
                 if(URLALLOW!=0&&ALLOW==0)
                    {
                      sprintf(&str1[0],"%s/urldenied.html",&denied_to[0]);
		    }  
                 if(USERDENIED!=0)
                    {
                      sprintf(&str1[0],"%s/denied.html",&denied_to[0]);
		    }  
                 if(DENIED!=0)
                    {
                      sprintf(&str1[0],"%s/urldenied.html",&denied_to[0]);
		    }  
                 if(REDIRECT!=0)
                    {
                      strncpy(&str1[0],&redir_to[0],254);
		    }  
                 sprintf(&str[0],"%s %s/- %s %s",&str1[0],&str2[0],&str3[0],&str4[0]);
                 fprintf(stdout,"%s\n",&str[0]);
               }
             fflush(stdout);
             if(DEBUG==1)
               printf("\n");
           }
      }

 return(0);
}






