/*      SAMS (Squid Account Management System
 *      Author: Dmitry Chemerik chemerik@mail.ru
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <ctype.h>
#include <dirent.h>
#include <fcntl.h>
#include <math.h>
#include <mysql.h>
#include <signal.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/un.h>
#include <syslog.h>
#include <time.h>
#include <unistd.h>

#include "config.h"
#include "define.h"
#include "tools.h"


int ANALOG, DISKRET, COUNTCLEAN,RECODE;
int sams_step;
sig_atomic_t child_exit_status;
static char str[BUFFER_SIZE];

/*
int SaveBackUpLogSquid(MYSQL *conn)
{
  FILE *fout;
  char filename[256];
  time_t tt;
  struct tm *t;
  MYSQL_ROW row,row2;
  MYSQL_RES *res,*res2;
  int flag,count;

  tt=time(NULL);
  t=localtime(&tt);

  sprintf(&filename[0],"squid_db.tar\n");
  if((fout=fopen(&filename[0], "wt" ))==NULL)
    {
      return(0);
    }
  printf("# SQUIDCTRL DUMP FOR MYSQL DATABASE\n");

  sprintf(&str[0],"SELECT * FROM squidlog.cache WHERE date<'%d-%d-%d' ",t->tm_year+1900,t->tm_mon+1,t->tm_mday);
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  while((row=mysql_fetch_row(res)))
    {
       sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers WHERE shablon='%s'&&enabled>'0'",row[0]);
       flag=mysql_query(conn,&str[0]);
       res2=mysql_store_result(conn);
       row2=mysql_fetch_row(res2);
    }
  mysql_free_result(res);



  fclose(fout);
}
*/

int RecodeFile(char *string,char *finpname,char *foutname)
{
  int finp, fout,i,j,len;
  char s2[BUFFER_SIZE];  
  finp=0;
  fout=0;

  len=strlen(&RECODECOMMAND[0]);
  if( strstr( &RECODECOMMAND[0], "%finp")!=0 && strstr( &RECODECOMMAND[0], "#" )==NULL )
     {
       finp=1;
     }
  if( strstr( &RECODECOMMAND[0], "%fout" )!=0 && strstr( &RECODECOMMAND[0], "#" )==NULL )
     {
       fout=10;
     }
//  sprintf(string,"\0");
  strncpy(string,"\0",1);
  for(j=0,i=0;i<len;i++)
     {
       
       if(RECODECOMMAND[i]==' ')
         {
	   s2[j++]='\0';
	   j=0;
	   if(!strcasecmp( &s2[0], "%finp" ))
	     {
	        strcpy(&s2[0],finpname);
	     }
	   if(!strcasecmp( &s2[0], "%fout" ))
	     {
	        strcpy(&s2[0],foutname);
	     }
           strcat(string,&s2[0]);
           strcat(string," ");
	 }
       else
         {
           s2[j++]=RECODECOMMAND[i];
	 }    
     }
  s2[j++]='\0';
  j=0;
  if(!strcasecmp( &s2[0], "%finp" ))
    {
       strcpy(&s2[0],finpname);
    }
  if(!strcasecmp( &s2[0], "%fout" ))
    {
       strcpy(&s2[0],foutname);
    }
  strcat(string,&s2[0]);
  if(DEBUG==1)
     printf("recode command = %s\n",string);
  
  return(finp+fout);

}

void clean_up_child_process(int signal_number)
{
  int status;
  wait(&status);
  child_exit_status = status;
}

int ChangeSQUIDconf(MYSQL *conn)
{
  char str[BUFFER_SIZE];
  char filefrom[256];
  char fileto[256];
  char method[128];
  FILE *finp,*fout;
  time_t tt;
  struct tm *t;
  MYSQL_ROW row,row2;
  MYSQL_RES *res,*res2;
  int flag,count,acount;

  sprintf(&method[0],"src");
  if(NTLM==1||NCSA==1)
    sprintf(&method[0],"proxy_auth");
  

  sprintf(&filefrom[0],"%s/squid.conf",&SQUIDROOTDIR[0]);
  sprintf(&fileto[0],"%s/squid.conf.bak",&SQUIDROOTDIR[0]);
  if((finp=fopen(&filefrom[0], "rt" ))==NULL)
    {
      //printf("Don't open file %s\n",&filefrom[0]);
      return(0);
    }
  if((fout=fopen(&fileto[0], "wt" ))==NULL)
    {
      //printf("Don't open file %s\n",&fileto[0]);
      return(0);
    }
  while(feof(finp)==0)
    {
       fgets( &buf[0], BUFFER_SIZE-1, finp ); 
       if((strstr( &buf[0], "_sams_" )==NULL&&strstr( &buf[0], "delay_pools" )==NULL&&strstr( &buf[0], "delay_class" )==NULL&&strstr(
       &buf[0], "delay_access" )==NULL&&strstr( &buf[0], "delay_parameters" )==NULL)||strstr( &buf[0], "#" )!=NULL)
         {
           if(strstr( &buf[0], "created by SAMS" )==NULL)
	     fprintf(fout,"%s",&buf[0]);
	   
         }
    }
 fclose(fout);
 fclose(finp);
 unlink(&filefrom[0]);


  if((finp=fopen(&fileto[0], "rt" ))==NULL)
    {
      //printf("Don't open file %s\n",&fileto[0]);
      return(0);
    }
  if((fout=fopen(&filefrom[0], "wt" ))==NULL)
    {
      //printf("Don't open file %s\n",&filefrom[0]);
      return(0);
    }
  tt=time(NULL);
  t=localtime(&tt);

  fprintf(fout,"# created by SAMS _sams_ %d-%d-%d %d:%d:%d\n",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
  while(feof(finp)==0)
    {
       fgets( &buf[0], BUFFER_SIZE-1, finp ); 
       fprintf(fout,"%s",&buf[0]);
       //if(DEBUG==1)
       //  printf("%s",&buf[0]);

       
       if(strstr( &buf[0], "#  TAG: acl" )!=0)
         {
           if(DEBUG==1)
             printf("TAG: acl found... START\n");
           sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           while((row=mysql_fetch_row(res)))
	     {
               count=0;
               if(RSAMS==1)
                  sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers WHERE shablon='%s'",row[0]);
               else   
		  sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers WHERE shablon='%s'&&enabled>'0'",row[0]);
               //if(DEBUG==1)
               //  printf("request: %s\n",&str[0]);
               flag=mysql_query(conn,&str[0]);
               res2=mysql_store_result(conn);
               row2=mysql_fetch_row(res2);
               count=atoi(row2[0]); 
               if(DEBUG==1)
                 printf("found %d users in template %s, create ACL\n",count,row[0]);
               mysql_free_result(res2);
               if(count>0)
	         {
                   fprintf(fout,"acl _sams_%s %s \"%s/%s.sams\"\n",row[0],&method[0],&SQUIDROOTDIR[0],row[0]);
                   if(DEBUG==1)
                     printf("acl _sams_%s %s \"%s/%s.sams\"\n",row[0],&method[0],&SQUIDROOTDIR[0],row[0]);
		 }
	     }
           mysql_free_result(res);

           //   
           sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='denied'");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           while((row=mysql_fetch_row(res)))
	     {
               count=0;
               sprintf(&str[0],"SELECT count(urls.url) FROM squidctrl.urls left join squidctrl.redirect ON urls.type=redirect.filename WHERE redirect.type = 'denied'&&redirect.filename='%s'",row[1]);
               flag=mysql_query(conn,&str[0]);
               res2=mysql_store_result(conn);
               row2=mysql_fetch_row(res2);
               count=atoi(row2[0]);
               if(count>0)
	         {
                   fprintf(fout,"acl _sams_%s url_regex \"%s/%s.sams\"\n",row[1],&SQUIDROOTDIR[0],row[1]);
                   if(DEBUG==1)
                     printf("acl _sams_%s url_regex \"%s/%s.sams\"\n",row[1],&SQUIDROOTDIR[0],row[1]);
		 }
	     }
           mysql_free_result(res);

           //   
           sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='allow'");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           while((row=mysql_fetch_row(res)))
	     {
               count=0;
               sprintf(&str[0],"SELECT count(urls.url) FROM squidctrl.urls left join squidctrl.redirect ON urls.type=redirect.filename WHERE redirect.type = 'allow'&&redirect.filename='%s'",row[1]);
               flag=mysql_query(conn,&str[0]);
               res2=mysql_store_result(conn);
               row2=mysql_fetch_row(res2);
               count=atoi(row2[0]);
               if(count>0)
	         {
                   fprintf(fout,"acl _sams_%s url_regex \"%s/%s.sams\"\n",row[1],&SQUIDROOTDIR[0],row[1]);
                   if(DEBUG==1)
                     printf("acl _sams_%s url_regex \"%s/%s.sams\"\n",row[1],&SQUIDROOTDIR[0],row[1]);
		 }
	     }
           mysql_free_result(res);


           if(DEBUG==1)
             printf("TAG: acl END\n\n");
         }


       if(strstr( &buf[0], "#  TAG: http_access" )!=0)
         {
           if(DEBUG==1)
             printf("TAG: http_access found...  START\n");
           sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           while((row=mysql_fetch_row(res)))
	     {
               count=0;
               if(RSAMS==1)   
		  sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers WHERE shablon='%s'",row[0]);
	       else
	          sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers WHERE shablon='%s'&&enabled>'0'",row[0]);
               flag=mysql_query(conn,&str[0]);
               res2=mysql_store_result(conn);
               row2=mysql_fetch_row(res2);
               count=atoi(row2[0]); 
               mysql_free_result(res2);
               if(DEBUG==1)
                 printf("found %d users in the template %s, create access rights\n",count,row[0]);

               if(count>0)
                 {
                   acount=0;
                   sprintf(&str[0],"SELECT count(redirect.filename) FROM squidctrl.sconfig left join squidctrl.redirect ON sconfig.set = redirect.filename WHERE sname = '%s'&&redirect.type='allow'\n",row[0]);
                   flag=mysql_query(conn,&str[0]);
                   res2=mysql_store_result(conn);
                   row2=mysql_fetch_row(res2);
		   acount=atoi(row2[0]);
                   if(DEBUG==1)
		     {
                       printf("template: %s\n",row[0]);
                       //printf("string: %s\n",&str[0]);
                       printf("found %d URL allow lists\n",acount);
		     }  
		   mysql_free_result(res2);
		   
                   if(acount>0&&(RGUARD==1||RSQUID==1))
                     fprintf(fout,"http_access deny _sams_%s ",row[0]);
                   else
                     fprintf(fout,"http_access allow _sams_%s ",row[0]);

                   if(DEBUG==1)
		     {
                       printf("http_access allow _sams_%s \n",row[0]);
                       printf("RGUARD==%d||RSQUID==%d \n",RGUARD,RSQUID);
		     }  

                   if(RGUARD==1||RSQUID==1)
		     {
                       if(acount>0)
		         {
                           sprintf(&str[0],"SELECT sconfig.sname, sconfig.set, redirect.filename, redirect.type FROM squidctrl.sconfig left join squidctrl.redirect ON sconfig.set = redirect.filename WHERE sname = '%s'&&redirect.type='allow'\n",row[0]);
                           flag=mysql_query(conn,&str[0]);
                           //if(DEBUG==1)
                           //  printf("request %d: %s \n",flag,&str[0]);
                           res2=mysql_store_result(conn);
                           while((row2=mysql_fetch_row(res2)))
	                     {
                               fprintf(fout," !_sams_%s",row2[1]);
                               if(DEBUG==1)
                                 printf(" !_sams_%s",row2[1]);

                             }
                           mysql_free_result(res2);
			 }  
                       else
		         {
                           sprintf(&str[0],"SELECT sconfig.sname, sconfig.set, redirect.filename, redirect.type FROM squidctrl.sconfig left join squidctrl.redirect ON sconfig.set = redirect.filename WHERE sname = '%s'&&redirect.type='denied'\n",row[0]);
                           flag=mysql_query(conn,&str[0]);
                           //if(DEBUG==1)
                           //  printf("request %d: %s \n",flag,&str[0]);
                           res2=mysql_store_result(conn);
                           while((row2=mysql_fetch_row(res2)))
	                     {
                               fprintf(fout," !_sams_%s",row2[1]);
                               if(DEBUG==1)
                                 printf(" !_sams_%s",row2[1]);

                             }
                           mysql_free_result(res2);
			 }  
                     }
                   fprintf(fout,"\n");
		 }
		 
		 
		 
	     }
           mysql_free_result(res);

           if(DEBUG==1)
             printf("TAG: http_access END\n");
         }

       if(strstr( &buf[0], "#  TAG: delay_class" )!=0)
         {
           if(DEBUG==1)
             printf("TAG: delay_class found\n");

           count=0;
           sprintf(&str[0],"SELECT squidusers.nick,squidusers.shablon,shablons.name,shablons.shablonpool,shablons.userpool FROM squidctrl.squidusers LEFT JOIN squidctrl.shablons ON squidusers.shablon=shablons.name GROUP BY squidusers.shablon");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           while((row=mysql_fetch_row(res)))
	     {
               count=count+1;
	     }
           fprintf(fout,"delay_pools %d\n",count);
           if(DEBUG==1)
             printf("delay_pools %d\n",count);
           mysql_free_result(res);
           sprintf(&str[0],"SELECT squidusers.nick,squidusers.shablon,shablons.name,shablons.shablonpool,shablons.userpool FROM squidctrl.squidusers LEFT JOIN squidctrl.shablons ON squidusers.shablon=shablons.name GROUP BY squidusers.shablon");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           count=1;
           while((row=mysql_fetch_row(res)))
	     {
               fprintf(fout,"delay_class %d 2\n",count);
               if(DEBUG==1)
                 printf("delay_class %d 2\n",count);
	       count=count+1;
	     }
           mysql_free_result(res);

           sprintf(&str[0],"SELECT squidusers.nick,squidusers.shablon,shablons.name,shablons.shablonpool,shablons.userpool FROM squidctrl.squidusers LEFT JOIN squidctrl.shablons ON squidusers.shablon=shablons.name GROUP BY squidusers.shablon");
           flag=mysql_query(conn,&str[0]);
           res=mysql_store_result(conn);
           count=1;
           while((row=mysql_fetch_row(res)))
	     {
               fprintf(fout,"delay_access %d allow _sams_%s\n",count,row[1]);
               fprintf(fout,"delay_access %d deny all\n",count);
               fprintf(fout,"delay_parameters %d %s/%s %s/%s\n",count,row[3],row[3],row[4],row[4]);
               if(DEBUG==1)
	         {
                   fprintf(fout,"delay_access %d allow _sams_%s\n",count,row[1]);
                   fprintf(fout,"delay_access %d deny all\n",count);
                   fprintf(fout,"delay_parameters %d %s/%s %s/%s\n",count,row[3],row[3],row[4],row[4]);
		 }
	       count=count+1;
	     }
           mysql_free_result(res);
         }
    }
 fclose(fout);
 fclose(finp);
 return(0);
}



int MakeACLFiles(MYSQL *conn)
{
  int count,i,j,ucount,ncsacount;
  char redirect_to[BUFFER_SIZE];
  char str[BUFFER_SIZE];
  char shablonname[128];
  MYSQL_ROW row,row2;
  MYSQL_RES *res,*res2;
  FILE *fout;

  int flag;

  BIGU=0;
  BIGD=0;
  NTLMDOMAIN=0;
  
  sprintf(&str[0],"SELECT redirect_to,bigd,bigu,ntlmdomain FROM squidctrl.sams");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  if(strcmp(row[1],"Y")==0)
                             {      BIGD=1;    }
  if(strcmp(row[2],"Y")==0)
                             {      BIGU=1;    }
  if(strcmp(row[3],"Y")==0)
                             {      NTLMDOMAIN=1;    }
  strcpy(&redirect_to[0],row[0]);
  mysql_free_result(res);


  /*   - SQUID  */
  if(RSQUID==1)
    {
      sprintf(&shablonname[0],"%s/redirector.sams",&SQUIDROOTDIR[0]);
      if((fout=fopen(&shablonname[0], "wt" ))==NULL)
        {
          //printf("Don't open file %s\n",&shablonname[0]);
          return(0);
        }
      fprintf(fout,"#!/usr/bin/perl\n");
      fprintf(fout,"$0 = 'redirect' ;\n");
      fprintf(fout,"$| = 1;\n\n");
      fprintf(fout,"@banners    = (");

      count=0;
      sprintf(&str[0],"SELECT count(urls.url) FROM squidctrl.urls left join squidctrl.redirect ON urls.type = redirect.filename WHERE redirect.type = 'redir'");
      flag=mysql_query(conn,&str[0]);
      res=mysql_store_result(conn);
      row=mysql_fetch_row(res);
      count=atoi(row[0]);
//?
      mysql_free_result(res);
      
      sprintf(&str[0],"SELECT urls.url, urls.type, redirect.filename, redirect.type FROM squidctrl.urls left join squidctrl.redirect ON urls.type = redirect.filename WHERE redirect.type = 'redir'");
      flag=mysql_query(conn,&str[0]);
      res=mysql_store_result(conn);
      for(i=0;i<count;i++)
         {
           row=mysql_fetch_row(res);
           fprintf(fout,"'%s'\n",row[0]);
	   //printf("redirect url: %s %s %s %s\n",row[0],row[1],row[2],row[3]);
           
         }
      fprintf(fout,"         'web\\.icq\\.com/client');\n");
      fprintf(fout,"while (<>) {\n");
      fprintf(fout,"    (\\$url, \\$who, \\$ident, \\$method) = /^(\\S+) (\\S+) (\\S+) (\\S+)\\$/ ;\n");
      fprintf(fout,"    \\$url = '%s'\n",&redirect_to[0]);
      fprintf(fout,"      if grep (\\$url=~/\\$_/i, @banners) ;\n");
      fprintf(fout,"    print \"\\$url \\$who \\$ident \\$method \\n\" ;\n");
      fprintf(fout,"}\n");
      mysql_free_result(res);
      fclose(fout);
      chmod(&shablonname[0],0755);
    
    }
  /*END     - SQUID        */


  /*          */
  count=0;
  sprintf(&str[0],"SELECT count(*) FROM squidctrl.redirect WHERE type='denied'||type='regex'");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  count=atoi(row[0]);
  mysql_free_result(res);
  sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='denied'||type='regex'");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<count;i++)
     {
       row=mysql_fetch_row(res);
       sprintf(&shablonname[0],"%s/%s.sams",&SQUIDROOTDIR[0],row[1]);
       //printf("found denied list: %s %s %s\n",row[0],row[1],&shablonname[0]);
       sprintf(&str[0],"SELECT count(*) FROM squidctrl.urls where type='%s'",row[1]);
       flag=mysql_query(conn,&str[0]);
       res2=mysql_store_result(conn);
       row2=mysql_fetch_row(res2);
       ucount=atoi(row2[0]); 
       //printf("denied list included %d url\n",ucount);
       mysql_free_result(res2);
       if(ucount>0)
         {
           if((fout=fopen(&shablonname[0], "wt" ))==NULL)
              {
                //printf("Don't open file %s\n",&shablonname[0]);
                return(0);
              }
           sprintf(&str[0],"SELECT * FROM squidctrl.urls where type='%s'",row[1]);
           flag=mysql_query(conn,&str[0]);
           res2=mysql_store_result(conn);
           for(j=0;j<ucount;j++)
	      {
                row2=mysql_fetch_row(res2);
                fprintf(fout,"%s\n",row2[0]);
                //printf("url found: %15s %15s \n",row2[1],row2[0]);
	      }
           mysql_free_result(res2);
           fclose(fout);

	 }

     }  
  mysql_free_result(res);
  /* END             */

  /*          */
  count=0;
  sprintf(&str[0],"SELECT count(*) FROM squidctrl.redirect WHERE type='allow'||type='regex'");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  count=atoi(row[0]);
  mysql_free_result(res);
  sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='allow'||type='regex'");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<count;i++)
     {
       row=mysql_fetch_row(res);
       sprintf(&shablonname[0],"%s/%s.sams",&SQUIDROOTDIR[0],row[1]);
       //printf("found denied list: %s %s %s\n",row[0],row[1],&shablonname[0]);
       sprintf(&str[0],"SELECT count(*) FROM squidctrl.urls where type='%s'",row[1]);
       flag=mysql_query(conn,&str[0]);
       res2=mysql_store_result(conn);
       row2=mysql_fetch_row(res2);
       ucount=atoi(row2[0]); 
       //printf("denied list included %d url\n",ucount);
       mysql_free_result(res2);
       if(ucount>0)
         {
           if((fout=fopen(&shablonname[0], "wt" ))==NULL)
              {
                //printf("Don't open file %s\n",&shablonname[0]);
                return(0);
              }
           sprintf(&str[0],"SELECT * FROM squidctrl.urls where type='%s'",row[1]);
           flag=mysql_query(conn,&str[0]);
           res2=mysql_store_result(conn);
           for(j=0;j<ucount;j++)
	      {
                row2=mysql_fetch_row(res2);
                fprintf(fout,"%s\n",row2[0]);
                //printf("url found: %15s %15s \n",row2[1],row2[0]);
	      }
           mysql_free_result(res2);
           fclose(fout);

	 }

     }  
  mysql_free_result(res);
  /* END             */



  /*         */
  ncsacount=0;
  count=0;
  sprintf(&str[0],"SELECT count(*) FROM squidctrl.shablons");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  row=mysql_fetch_row(res);
  count=atoi(row[0]);
  mysql_free_result(res);
  sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
  flag=mysql_query(conn,&str[0]);
  res=mysql_store_result(conn);
  for(i=0;i<count;i++)
     {
       row=mysql_fetch_row(res);
       if(DEBUG==1)
         printf("Creating SAMS users list %s/%s.sams\n",&SQUIDROOTDIR[0],row[0]);
       sprintf(&shablonname[0],"%s/%s.sams",&SQUIDROOTDIR[0],row[0]);
       //printf("found template: %s %s %s\n",row[0],row[1],&shablonname[0]);
       if(RSAMS==0)
         sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers where shablon='%s'&&enabled>'0'",row[0]);
       else
         sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers where shablon='%s'",row[0]);
       flag=mysql_query(conn,&str[0]);
       res2=mysql_store_result(conn);
       row2=mysql_fetch_row(res2);
       ucount=atoi(row2[0]); 
       //printf("template included %d users\n",ucount);
       mysql_free_result(res2);
       if(ucount>0)
         {
           if((fout=fopen(&shablonname[0], "wt" ))==NULL)
              {
                //printf("Don't open file %s\n",&shablonname[0]);
                return(0);
              }
           if(RSAMS==0)
             sprintf(&str[0],"SELECT * FROM squidctrl.squidusers WHERE shablon='%s'&&enabled>'0'",row[0]);
           else
             sprintf(&str[0],"SELECT * FROM squidctrl.squidusers WHERE shablon='%s'",row[0]);
           flag=mysql_query(conn,&str[0]);
           res2=mysql_store_result(conn);
           for(j=0;j<ucount;j++)
	      {
                row2=mysql_fetch_row(res2);
                if(NTLM==1) 
		  {
                    if(BIGD==1)
		      {
                        str2upper(row2[6]);
		      }
                    if(BIGU==1)
                      {
                        str2upper(row2[1]);
		      }
                    if(NTLMDOMAIN==1)
                      {
                        fprintf(fout,"%s+%s\n",row2[6],row2[1]);
                        fprintf(fout,"%s\\%s",row2[6],row2[1]);
		      }
		    else  	
                      {
                        fprintf(fout,"%s",row2[1]);
		      }
		  }      
                if(NCSA==1) 
		  {
                     fprintf(fout,"%s",row2[1]);
                     if(ncsacount==0)
		       {
                          if(DEBUG==1)
                            printf("Creating %s/ncsa.sams user: %s\n",&SQUIDROOTDIR[0],row2[1]);
                          sprintf(&str[0],"htpasswd -cb %s/ncsa.sams %s %s",&SQUIDROOTDIR[0],row2[1],row2[13]);
                          system(&str[0]);
		       } 
                     else
		       {
                          if(DEBUG==1)
                            printf("Creating %s/ncsa.sams user: %s\n",&SQUIDROOTDIR[0],row2[1]);
                          sprintf(&str[0],"htpasswd -b %s/ncsa.sams %s %s",&SQUIDROOTDIR[0],row2[1],row2[13]);
                          system(&str[0]);
		       } 
                     ncsacount++;

		  }      
                if(IP==1) 
		  {
                    fprintf(fout,"%s/255.255.255.255",row2[11]);
		  
                  }
                fprintf(fout,"\n");
                //printf("user found: %15s+%15s %15s/%15s\n",row2[6],row2[1],row2[11],row2[12]);
	      }
           mysql_free_result(res2);
           fclose(fout);
           if(NTLM==1&&RECODE==1)
	     {
                sprintf(&buf[0],"%s.out",&shablonname[0]);
	        if(RecodeFile(&str[0],&shablonname[0],&buf[0])<10)
		   {
		      system(&str[0]);
		   }
		else   
		   {
		      system(&str[0]);
                      sprintf(&str[0],"mv %s.out %s",&shablonname[0],&shablonname[0]);
		      system(&str[0]);
		   }

	     }      
     
	 }

     }  
  mysql_free_result(res);
  /* END            */

  /*          SQUIDGUARD   */
  if(RGUARD==1)
    {

       /*     SQUIDGUARD    */
       count=0;
       sprintf(&str[0],"SELECT count(*) FROM squidctrl.shablons");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       row=mysql_fetch_row(res);
       count=atoi(row[0]);
       mysql_free_result(res);
       sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       for(i=0;i<count;i++)
          {
            row=mysql_fetch_row(res);
            sprintf(&shablonname[0],"%s/%s.squidguard",&SQUIDROOTDIR[0],row[0]);
            //printf("found template: %s %s %s\n",row[0],row[1],&shablonname[0]);
            sprintf(&str[0],"SELECT count(*) FROM squidctrl.squidusers where shablon='%s'&&enabled>'0'",row[0]);
            flag=mysql_query(conn,&str[0]);
            res2=mysql_store_result(conn);
            row2=mysql_fetch_row(res2);
            ucount=atoi(row2[0]); 
            //printf("template included %d users\n",ucount);
            mysql_free_result(res2);
            if(ucount>0)
              {
                if((fout=fopen(&shablonname[0], "wt" ))==NULL)
                   {
                     //printf("Don't open file %s\n",&shablonname[0]);
                     return(0);
                   }
                sprintf(&str[0],"SELECT * FROM squidctrl.squidusers WHERE shablon='%s'&&enabled>'0'",row[0]);
                flag=mysql_query(conn,&str[0]);
                res2=mysql_store_result(conn);
                for(j=0;j<ucount;j++)
	           {
                     row2=mysql_fetch_row(res2);
                     if(NTLM==1&&NTLMDOMAIN==1) 
		       {
                         if(BIGD==1)
		           {
//                             fprintf(fout,"%s+",str2upper(row2[6]));
                             str2upper(row2[6]);
                             fprintf(fout,"%s+",row2[6]);
		           }
		         else  
                           {
                             fprintf(fout,"%s+",row2[6]);
		           }
		       }      
                     if(NTLM==1||NCSA==1) 
		       {
                         if(NTLM==1&&BIGU==1)
		           {
//                             fprintf(fout,"%s",str2upper(row2[1]));
                             str2upper(row2[1]);
                             fprintf(fout,"%s",row2[1]);
		           }
		         else  
                           {
                             fprintf(fout,"%s",row2[1]);
		           }
		       }      
                     if(IP==1) 
		       {
                         fprintf(fout,"%s",row2[11]);
                       }
                     fprintf(fout,"\n");
                     //printf("user found: %15s+%15s %15s/%15s\n",row2[6],row2[1],row2[11],row2[12]);
	           }
                mysql_free_result(res2);
                fclose(fout);

	      }

          }  
       mysql_free_result(res);
       /* END       SQUIDGUARD     */

       sprintf(&str[0],"SELECT count(*) FROM squidctrl.redirect WHERE type='redir'");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       row=mysql_fetch_row(res);
       count=atoi(row[0]);

       sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='redir'");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       for(i=0;i<count;i++)
         {
            row=mysql_fetch_row(res);

            sprintf(&shablonname[0],"%s/sams_%s",&SQUIDGUARDDBPATH[0],row[1]);
            if((fout=fopen(&shablonname[0], "wt" ))==NULL)
              {
                 //printf("Don't open file %s\n",&shablonname[0]);
                 return(0);
              }
            sprintf(&str[0],"SELECT * FROM squidctrl.urls WHERE type='%s'",row[1]);
            flag=mysql_query(conn,&str[0]);
            res2=mysql_store_result(conn);
            while((row2=mysql_fetch_row(res2)))
              {
                 fprintf(fout,"%s\n",row2[0]);

              }
            mysql_free_result(res2);
            fclose(fout);


         }
       mysql_free_result(res);

       /*      squidguard.sams     */
       sprintf(&shablonname[0],"%s/squidguard.sams",&SQUIDROOTDIR[0]);
       if((fout=fopen(&shablonname[0], "wt" ))==NULL)
         {
            //printf("Don't open file %s\n",&shablonname[0]);
            return(0);
         }
       fprintf(fout,"dbhome %s\n",&SQUIDGUARDDBPATH[0]);
       fprintf(fout,"logdir %s\n\n",&SQUIDGUARDLOGPATH[0]);

       sprintf(&str[0],"SELECT * FROM squidctrl.redirect WHERE type='redir'");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       while((row=mysql_fetch_row(res)))
        {
           fprintf(fout,"dest sams_%s {\n",row[1]);
           fprintf(fout," domainlist sams_%s\n",row[1]);
           if(strlen(row[4])>1)
               fprintf(fout," redirect %s\n",row[4]);
           fprintf(fout,"}\n");
        }
       mysql_free_result(res);

     sprintf(&str[0],"DISTINCT name, domain, url, expr FROM squidctrl.sguard");
     flag=mysql_query(conn,&str[0]);
     res=mysql_store_result(conn);
     while((row=mysql_fetch_row(res)))
       {
         fprintf(fout,"dest %s {\n",row[0]);
         if(strcmp(row[1],"Y")==0)
           {
              fprintf(fout," domainlist %s/domains\n",row[0]);
           }
         if(strcmp(row[2],"Y")==0)
           {
              fprintf(fout," urllist %s/urls\n",row[0]);
           }
         if(strcmp(row[3],"Y")==0)
           {
              fprintf(fout," expressionlist %s/expressions\n",row[0]);
           }
         fprintf(fout,"}\n");
       }
     mysql_free_result(res);

       sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       while((row=mysql_fetch_row(res)))
         {
           fprintf(fout,"source sams_%s {\n",row[0]);
           if(NTLM==1||NCSA==1)
             {
               fprintf(fout,"   userlist %s/%s.squidguard\n}\n\n",&SQUIDROOTDIR[0],row[0]);
             }
           if(IP==1)
             {
               fprintf(fout,"   iplist %s/%s.squidguard\n}\n\n",&SQUIDROOTDIR[0],row[0]);
             }

         }
       mysql_free_result(res);

       fprintf(fout,"acl {\n");

       sprintf(&str[0],"SELECT * FROM squidctrl.shablons");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       while((row=mysql_fetch_row(res)))
         {
           fprintf(fout,"sams_%s {\n",row[0]);
           fprintf(fout,"   pass");
           sprintf(&str[0],"SELECT * FROM squidctrl.sconfig,squidctrl.redirect WHERE sname=\"%s\" and type=\"redir\" and sconfig.set=filename",row[0]);
           flag=mysql_query(conn,&str[0]);
           res2=mysql_store_result(conn);
           while((row2=mysql_fetch_row(res2)))
              {
                 fprintf(fout," !sams_%s",row2[1]);
              }
           mysql_free_result(res2);
           sprintf(&str[0],"SELECT sguard.name as name FROM squidctrl.shablons,squidctrl.sguard WHERE shablons.name=\"%s\" and shablons.name=sguard.sname",row[0]);
           flag=mysql_query(conn,&str[0]);
           res2=mysql_store_result(conn);
           while((row2=mysql_fetch_row(res2)))
              {
                 fprintf(fout," !%s",row2[0]);
              }
           mysql_free_result(res2);
           fprintf(fout," any\n");
           if(strlen(row[4])>1)
              fprintf(fout,"    redirect %s?clientaddr=%s&clientident=%s&srcclass=%s&targetclass=%s&url=%s\n",row[4],"%a","%i","%s","%t","%u");
           fprintf(fout,"}\n");
        }                   
       mysql_free_result(res);

       fprintf(fout,"\n\ndefault {\n   pass none\n");
       sprintf(&str[0],"SELECT redirect_to FROM squidctrl.sams");
       flag=mysql_query(conn,&str[0]);
       res=mysql_store_result(conn);
       row=mysql_fetch_row(res);
       if(strlen(row[0])>1)
          fprintf(fout,"    redirect %s?clientaddr=%s&clientident=%s&srcclass=%s&targetclass=%s&url=%s\n",row[0],"%a","%i","%s","%t","%u");
       fprintf(fout,"} }\n\n");
       mysql_free_result(res);
       fclose(fout);
       /* END      squidguard.sams     */
    }
  /*  END        SQUIDGUARD   */
 return(0);
}


void ReadSAMSFlags(MYSQL *conn2)
{
  MYSQL_RES *res;
  MYSQL_ROW row;
  int flag;
  sprintf(&str[0],"SELECT endvalue,auth,ntlmdomain,sleep,redirector,parser_time,parser,count_clean,nameencode FROM squidctrl.sams");
  flag=mysql_query(conn2,&str[0]);
  res=mysql_store_result(conn2);
  row=mysql_fetch_row(res);

  IP=0;
  NCSA=0;
  NTLM=0; 
  if(DEBUG==1)
    printf("    User autentification... ");
  if(strcmp(row[1],"ncsa")==0)
    {
      NCSA=1;
      if(DEBUG==1)
         printf("NCSA\n");
    }
  if(strcmp(row[1],"ntlm")==0)
    {
      NTLM=1;
      if(DEBUG==1)
         printf("NTLM\n");
    }
  if(strcmp(row[1],"ip")==0)
    {
      IP=1;
      if(DEBUG==1)
         printf("IP\n");
    }
  if(strcmp(row[2],"Y")==0)
    {
      NTLMDOMAIN=1;
      if(DEBUG==1)
         printf("    Windows domain used\n");
    }

  if(DEBUG==1)
    {
       printf("    Sleep time of samsdaemon... ");
    }
  SLEEP=atoi(row[3]);
  if(DEBUG==1)
    {
       printf(" %d second\n",SLEEP);
    }

  if(DEBUG==1)
    printf("    Redirector... ");
  if(strcmp(row[4],"sams")==0)
    {
      RSAMS=1;
      if(DEBUG==1)
         printf("SAMS\n");
    }
  if(strcmp(row[4],"squidguard")==0)
    {
      RGUARD=1;
      if(DEBUG==1)
         printf("SQUIDGUARD\n");
    }
  if(strcmp(row[4],"squid")==0)
    {
      RSQUID=1;
      if(DEBUG==1)
         printf("SQUID\n");
    }

  if(DEBUG==1)
    printf("    SQUID log parser... ");
  sams_step=1;
  if(strcmp(row[6],"analog")==0)
    {
      ANALOG=1;
      if(DEBUG==1)
         printf("analog\n");
    }
  if(strcmp(row[6],"diskret")==0)
    {
      sams_step=atoi(row[5]);
      DISKRET=1;
      if(DEBUG==1)
         printf("diskret\n");
    }


  if(DEBUG==1)
    printf("    User traffic cleaner... ");
  if(strcmp(row[7],"Y")==0)
    {
      COUNTCLEAN=1;
      if(DEBUG==1)
         printf("YES\n");
    }
  else
    {
      if(DEBUG==1)
         printf("NO\n");
    }
    
  if(DEBUG==1)
    printf("    User name recode... ");
  if(strcmp(row[8],"Y")==0)
    {
      RECODE=1;
      if(DEBUG==1)
         printf("YES\n");
    }
  else
    {
      if(DEBUG==1)
         printf("NO\n");
    }


  mysql_free_result(res);
}


int main (int argc, char *argv[])
{
  int i;
  MYSQL *conn,*conn2;
  MYSQL_RES *res;
  MYSQL_ROW row;
  int flag;
  pid_t pid,childpid,parentpid;
  time_t tt;
  struct tm *t;
  int sams_sec;
  int sams_month;
  struct sigaction sigchld_action;

  sams_sec=0;
  printf("Starting samsdaemon\n");

  for(i=0;i<argc;i++)
     {
       if(strstr(argv[i],"--help")!=0||strstr(argv[i],"-h")!=0)
          {
            printf("Usage: samsdaemon [options]\n");
            printf(" -h, --help       show this message.\n");
            printf(" -p, --print      print additional information.\n");
            printf(" -d, --debug      print debug message.\n");
            exit(0);
          }
       if(strstr(argv[i],"--print")!=0||strstr(argv[i],"-p")!=0)
          {
            PRINT=1;
          }
       if(strstr(argv[i],"--debug")!=0||strstr(argv[i],"-d")!=0)
          {
            DEBUG=1;
          }
     }


  pid = getpid();
  if(DEBUG==1)
    {
      printf("Starting process: pid = %d\n",pid);
    }  
  if(access("/var/run/samsdaemon.pid",F_OK)==0)
    {
      if(TestPID("/var/run/samsdaemon.pid")!=0)
         exit(0);
    }

  if(DEBUG==1)
     printf("Read SAMS configuration... ");
  readconf();
  if(DEBUG==1)
     printf("Ok \n");
  conn = do_connect(&MYSQLHOSTNAME[0],&MYSQLUSER[0], &MYSQLPASSWORD[0],
                   &MYSQLDATABASE[0], def_port_num, def_socket_name, 0);
  if (conn == NULL)
                    exit(1);
  conn2 = do_connect(&MYSQLHOSTNAME[0],&MYSQLUSER[0], &MYSQLPASSWORD[0],
                   &SQUIDCTRLDATABASE[0], def_port_num, def_socket_name, 0);
  if (conn2 == NULL)
                    exit(1);
  if(DEBUG==1)
     printf("Read SAMS properties... \n");
  ReadSAMSFlags(conn2);
  if(DEBUG==1)
     printf("Ok \n");

  i=0;
  tt=time(NULL);
  t=localtime(&tt);
  if(DEBUG==1)
    printf(" SQUID log parser time=%d min\n",sams_step);
  printf("start time: %d-%d-%d %d:%d:%d\n",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);


  if(ANALOG==1)  
    {
       printf("starting FIFO log parser/ parser time=%d %d\n",sams_step,sams_sec);
       printf("start time: %d-%d-%d %d:%d:%d\n",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
       system("samsf");
    }

  sams_month=t->tm_mon+1;
  sams_sec=(60*sams_step)-t->tm_sec;
/**/
  childpid=0;
  if(DEBUG==0)
    {
      parentpid=getppid();
      childpid=fork();
    }
  if(childpid==0)
    {
       if(DEBUG==0)
         {
            pid = getpid();
            if(SavePID(pid,"/var/run/samsdaemon.pid")!=0)
              exit(0);
	 }    
/**/
       memset(&sigchld_action,0,sizeof(sigchld_action));
       sigchld_action.sa_handler=&clean_up_child_process;
       sigaction (SIGCHLD, &sigchld_action, NULL);
  
       if(DEBUG==0)
         openlog("samsdaemon",LOG_PID | LOG_CONS , LOG_DAEMON);
       while(SLEEP>0)
         {
           sams_sec-=SLEEP;
           if(DEBUG==1)
              printf("countdown: %d\n",sams_sec);
	   //else
	    //  syslog(LOG_DEBUG,"countdown: %d\n",sams_sec);      
           if(sams_sec<0)
             {
               tt=time(NULL);
               t=localtime(&tt);
               sams_sec=(60*sams_step);

               if(sams_month!=(t->tm_mon+1)&&COUNTCLEAN==1)  
                 {
                   sams_month=t->tm_mon+1;
                   if(DEBUG==1)
                     printf("starting user traffic cleaner\n");
                   if(DEBUG==0)
		     syslog(LOG_DEBUG,"SAMS: users traffic counters cleaned\n");
                   sprintf(&str[0],"UPDATE squidctrl.squidusers SET size='0',enabled='1' WHERE enabled>='0'");
                   flag=mysql_query(conn2,&str[0]);
                   if(flag!=0)
                     {
                        printf("error: can't clear user traffic counter\n");
                     }
                   else
                     {
                        sprintf(&str[0],"UPDATE squidctrl.reconfig SET action='reconfig',service='squid'");
                        flag=mysql_query(conn2,&str[0]);
                        if(DEBUG==1)
                           printf("SAMS: users traffic counter is cleaned\n");
                     }

                 }
               if(DISKRET==1)  
                 {
                   if(DEBUG==1)
		     { 
                       printf("starting log parser/ parser time=%d %d\n",sams_step,sams_sec);
                       printf("start time: %d-%d-%d %d:%d:%d\n",t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
		     }  
                   childpid=fork();
                   if(childpid==0)
                     {
                       //if(DEBUG==0)
		    //     syslog(LOG_DEBUG,"starting child process %s/bin/sams\n",&SAMSPATH[0]);
                       sprintf(&str[0],"%s/bin/sams",&SAMSPATH[0]);
                       system(&str[0]);
		       exit(0);
                     }
                 }
             }
           sprintf(&str[0],"SELECT action,service FROM squidctrl.reconfig WHERE service='squid'&&action='reconfig'");
           flag=mysql_query(conn2,&str[0]);
           res=mysql_store_result(conn2);
           //    SQUID
           if(mysql_num_rows(res)>0)  
             {
               readconf();
               ReadSAMSFlags(conn2);
               //sprintf(&str[0],"UPDATE squidctrl.reconfig SET action=\'\'");
               sprintf(&str[0],"DELETE FROM squidctrl.reconfig WHERE service='squid'&&action='reconfig'");
               flag=mysql_query(conn,&str[0]);
               if(flag!=0)
                 {
                    //printf("error: can't update end file counter\n");
                    exit(1);
                 }
               UnlinkFiles(&SQUIDROOTDIR[0],".sams");
               UnlinkFiles(&SQUIDROOTDIR[0],".squidguard");
               MakeACLFiles(conn2);
	       sleep(1);
               ChangeSQUIDconf(conn2);
	       sleep(1);
               if(RGUARD==1)
	         {
                    sprintf(&str[0],"squidGuard -C all -c %s/squidguard.sams",&SQUIDROOTDIR[0]);
                    system(&str[0]);
                    sprintf(&str[0],"chown nobody:nobody %s/sams_*",&SQUIDGUARDDBPATH[0]);
                    system(&str[0]);
	         }
               childpid=fork();
               if(childpid==0)
                 {
                    sprintf(&str[0],"%s/squid  -k reconfigure",&SQUIDPATH[0]);
                    system(&str[0]);
  	            exit(0);
                 }
	      }
           sleep(SLEEP);
         }
       if(DEBUG==0)
          RmPID("/var/run/samsdaemon.pid");
/**/
    }
/**/  


  return(0);
}
